<?php
/**
 * The template for displaying the footer
 *
 * Contains the closing of the #content div and all content after
 *
 * 
 * @package Karen
 * @since Karen 0.1.0
 */
?>

		</div><!-- .site-content -->

		<footer id="colophon" class="site-footer" role="contentinfo">
			<?php if (	is_active_sidebar( 'footer-widget-wide' ) ||
						is_active_sidebar( 'footer-widget-1' ) ||
						is_active_sidebar( 'footer-widget-2' ) ||
						is_active_sidebar( 'footer-widget-3' ) ||
						is_active_sidebar( 'footer-widget-4' ) ) : ?>

				<div id="footer-widget" class="footer-widget-container clear">
					<?php get_sidebar('footer'); ?>
					<hr>
				</div>
			<?php endif; ?>

			<?php if ( has_nav_menu( 'primary' ) ) : ?>
				<nav class="main-navigation" role="navigation" aria-label="<?php _e( 'Footer Primary Menu', 'karen' ); ?>">
					<?php
						wp_nav_menu( array(
							'theme_location' => 'primary',
							'menu_class'     => 'primary-menu',
						 ) );
					?>
				</nav><!-- .main-navigation -->
			<?php endif; ?>

			<?php if ( has_nav_menu( 'social' ) ) : ?>
				<nav class="social-navigation" role="navigation" aria-label="<?php _e( 'Footer Social Links Menu', 'karen' ); ?>">
					<?php
						wp_nav_menu( array(
							'theme_location' => 'social',
							'menu_class'     => 'social-links-menu',
							'depth'          => 1,
							'link_before'    => '<span class="screen-reader-text">',
							'link_after'     => '</span>',
						) );
					?>
				</nav><!-- .social-navigation -->
			<?php endif; ?>

			<div class="site-info">
				<?php
					/**
					 * Fires before the karen footer text for footer customization.
					 *
					 * @since Karen 0.1.0
					 */
					do_action( 'karen_credits' );
				?>
				<?php 
				if ( $footer_credit = get_theme_mod('footer_credit', false) ) : 
					echo karen_sanitize_footer_credit( $footer_credit );
				else : ?>
					<span class="site-title"><a href="<?php echo esc_url( home_url( '/' ) ); ?>" rel="home"><?php bloginfo( 'name' ); ?></a></span> 
					<?php _e('Powered by', 'karen'); ?> <a href="<?php echo esc_url( __( 'https://wordpress.org/', 'karen' ) ); ?>"><?php printf( __( 'WordPress', 'karen' ) ); ?></a> <?php _e('and designed by ', 'karen'); ?> <a href="<?php echo esc_url( __( 'http://www.fortypixels.com', 'karen' ) ); ?>"><?php printf( __( 'FortyPixels', 'karen' ) ); ?></a>
				<?php endif; ?>
			</div><!-- .site-info -->
		</footer><!-- .site-footer -->
	</div><!-- .site-inner -->
</div><!-- .site -->

<?php wp_footer(); ?>
</body>
</html>
