<?php
/**
 * The template part for displaying single posts
 *
 * 
 * @package Karen
 * @since Karen 0.1.0
 */
?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
	<header class="entry-header">
		<?php the_title( '<h1 class="entry-title">', '</h1>' ); ?>
	</header><!-- .entry-header -->

	<?php karen_excerpt(); ?>

	<?php karen_post_thumbnail(); ?>

	<footer class="entry-footer">
		<?php karen_entry_meta(); ?>
		<?php
			edit_post_link(
				sprintf(
					/* translators: %s: Name of current post */
					__( 'Edit<span class="screen-reader-text"> "%s"</span>', 'karen' ),
					get_the_title()
				),
				'<span class="edit-link">',
				'</span>'
			);
		?>

	</footer><!-- .entry-footer -->

	<div class="entry-content">
		<?php
			the_content();

			wp_link_pages( array(
				'before'      => '<div class="page-links"><span class="page-links-title">' . __( 'Pages:', 'karen' ) . '</span>',
				'after'       => '</div>',
				'link_before' => '<span>',
				'link_after'  => '</span>',
				'pagelink'    => '<span class="screen-reader-text">' . __( 'Page', 'karen' ) . ' </span>%',
				'separator'   => '<span class="screen-reader-text">, </span>',
			) );

			if ( 'post' === get_post_type() ) {
				echo '<p>';
				karen_entry_tags();
				echo '</p>';
			}
			
			karen_related_posts();

			if ( '' !== get_the_author_meta( 'description' ) ) {
				get_template_part( 'template-parts/biography' );
			}
		?>
	</div><!-- .entry-content -->

</article><!-- #post-## -->
