<?php
/**
 * The template part for displaying content
 *
 * 
 * @package Karen
 * @since Karen 0.1.0
 */
?>
<?php
$new_class = '';
if ( $wp_query->current_post === 0 ) {
	$new_class = 'display-featured';
}elseif ( ! has_post_thumbnail() ) {
	$new_class = 'no-thumbnail display-overlay';
} elseif ( has_tag( explode(',', get_theme_mod('overlay_image_tag') ) ) ){
	$new_class = 'display-overlay';
}
?>
<article id="post-<?php the_ID(); ?>" <?php post_class($new_class); ?>>

	<?php karen_post_thumbnail(); ?>

	<div>
		<header class="entry-header">
			<?php if ( is_sticky() && is_home() && ! is_paged() ) : ?>
				<span class="sticky-post"><?php _e( 'Featured', 'karen' ); ?></span>
			<?php endif; ?>

			<?php the_title( sprintf( '<h2 class="entry-title"><a href="%s" rel="bookmark">', esc_url( get_permalink() ) ), '</a></h2>' ); ?>
		</header><!-- .entry-header -->

		<footer class="entry-footer">
			<?php karen_entry_meta(); ?>
			<?php
				edit_post_link(
					sprintf(
						/* translators: %s: Name of current post */
						__( 'Edit<span class="screen-reader-text"> "%s"</span>', 'karen' ),
						get_the_title()
					),
					'<span class="edit-link">',
					'</span>'
				);
			?>
		</footer><!-- .entry-footer -->

		<div class="entry-content">
			<?php

				the_excerpt();
			?>
		</div><!-- .entry-content -->

	</div>

</article><!-- #post-## -->
