<?php
/**
 * The header for our theme.
 *
 * This is the template that displays all of the <head> section and everything up until <div id="content">
 *
 * @package shopstar
 */
global $woocommerce;
?><!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="profile" href="http://gmpg.org/xfn/11">
<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>">

<?php wp_head(); ?>
</head>

<body <?php body_class(); ?>>

<?php
if ( get_theme_mod( 'shopstar-layout-site', customizer_library_get_default( 'shopstar-layout-site' ) ) == 'shopstar-layout-site-boxed' ) { ?>
	<div class="boxed container">
<?php
}

global $queried_object, $slider_shortcode;

if (!$queried_object) {
	
	if ( shopstar_is_woocommerce_activated() && is_woocommerce() ) {
		
		if ( is_shop() ) {
			$queried_object = get_post( get_option( 'woocommerce_shop_page_id' ) );
		}
				
	} else {
		$queried_object = get_queried_object();
	}
}

if ($queried_object) {
	$custom_fields = get_post_custom($queried_object->ID);
	$slider_shortcode = trim($custom_fields["slider_shortcode"][0]);
}

global $show_slider, $slider_type;
$show_slider = false;

// Check if a slider should display
if ( is_front_page() && get_theme_mod( 'shopstar-slider-type', customizer_library_get_default( 'shopstar-slider-type' ) ) == 'shopstar-slider-default' && empty($slider_shortcode) ) {
	$show_slider = true;
	$slider_type = 'default';
} else if ( is_front_page() && get_theme_mod( 'shopstar-slider-type', customizer_library_get_default( 'shopstar-slider-type' ) ) == 'shopstar-slider-plugin' && get_theme_mod( 'shopstar-slider-plugin-shortcode', customizer_library_get_default( 'shopstar-slider-plugin-shortcode' ) ) != '' && empty($slider_shortcode) ) {
	$show_slider = true;
	$slider_type = 'plugin';
} else if ( !is_front_page() && !is_single() && get_theme_mod( 'shopstar-slider-all-pages', customizer_library_get_default( 'shopstar-slider-all-pages' ) ) && get_theme_mod( 'shopstar-slider-type', customizer_library_get_default( 'shopstar-slider-type' ) ) == 'shopstar-slider-default' && empty($slider_shortcode) ) {
	$show_slider = true;
	$slider_type = 'default';
} else if ( !is_front_page() && !is_single() && get_theme_mod( 'shopstar-slider-all-pages', customizer_library_get_default( 'shopstar-slider-all-pages' ) ) && get_theme_mod( 'shopstar-slider-type', customizer_library_get_default( 'shopstar-slider-type' ) ) == 'shopstar-slider-plugin' && get_theme_mod( 'shopstar-slider-plugin-shortcode', customizer_library_get_default( 'shopstar-slider-plugin-shortcode' ) ) != '' && empty($slider_shortcode) ) {
	$show_slider = true;
	$slider_type = 'plugin';
} else if ( !is_front_page() && is_single() && get_theme_mod( 'shopstar-slider-blog-posts', customizer_library_get_default( 'shopstar-slider-blog-posts' ) ) && get_theme_mod( 'shopstar-slider-type', customizer_library_get_default( 'shopstar-slider-type' ) ) == 'shopstar-slider-default' && empty($slider_shortcode) ) {
	$show_slider = true;
	$slider_type = 'default';
} else if ( !is_front_page() && is_single() && get_theme_mod( 'shopstar-slider-blog-posts', customizer_library_get_default( 'shopstar-slider-blog-posts' ) ) && get_theme_mod( 'shopstar-slider-type', customizer_library_get_default( 'shopstar-slider-type' ) ) == 'shopstar-slider-plugin' && get_theme_mod( 'shopstar-slider-plugin-shortcode', customizer_library_get_default( 'shopstar-slider-plugin-shortcode' ) ) != '' && empty($slider_shortcode) ) {
	$show_slider = true;
	$slider_type = 'plugin';
} else if ( !empty($slider_shortcode) ) {
	$show_slider = true;
	$slider_type = 'shortcode';
}

global $show_header_image, $header_image_type;
$show_header_image = false;

// Check if a header image should display
if ( is_front_page() && get_header_image() && get_theme_mod( 'shopstar-slider-type', customizer_library_get_default( 'shopstar-slider-type' ) ) == 'shopstar-no-slider' ) {
	$show_header_image = true;
	$header_image_type = 'theme_settings';
} else if ( !is_front_page() && !is_single() && $queried_object && has_post_thumbnail( $queried_object ) && get_theme_mod( 'shopstar-layout-featured-image-page-headers', customizer_library_get_default( 'shopstar-layout-featured-image-page-headers' ) ) ) {
	$show_slider = false;
	$show_header_image = true;
	$header_image_type = 'featured_image';
}

?>

    <?php
    if ( get_theme_mod( 'shopstar-header-layout', customizer_library_get_default( 'shopstar-header-layout' ) ) == 'shopstar-header-layout-centered' ) :
		get_template_part( 'library/template-parts/header', 'centered' );
	else :
		get_template_part( 'library/template-parts/header', 'left-aligned' );
	endif;
	?>
	
	<script>
    var shopstarSliderTransitionSpeed = parseInt(<?php echo intval( get_theme_mod( 'shopstar-slider-transition-speed', customizer_library_get_default( 'shopstar-slider-transition-speed' ) ) ); ?>);
    var shopstarSliderTransitionEffect = '<?php echo get_theme_mod( 'shopstar-slider-transition-effect', customizer_library_get_default( 'shopstar-slider-transition-effect' ) ); ?>';
    
    <?php if ( get_theme_mod( 'shopstar-slider-autoscroll', customizer_library_get_default( 'shopstar-slider-autoscroll' ) ) ) : ?>
    	var shopstarSliderSpeed = parseInt(<?php echo intval( get_theme_mod( 'shopstar-slider-speed', customizer_library_get_default( 'shopstar-slider-speed' ) ) ); ?>);
    <?php else : ?>
    	var shopstarSliderSpeed = false;
    <?php endif; ?>
	</script>
	
	<?php
	if ( $show_slider ) :
		get_template_part( 'library/template-parts/slider' );
	elseif ( $show_header_image ) :
		get_template_part( 'library/template-parts/header-image' );
	endif;
	?>
		
	<div id="content" class="site-content">
		<div class="container">
			<div class="padder">